% Wood Wacker
% This is a side scorller game like Mario where you are a lumberjack trying to save the forest
% Created by Adam Lamont Jun 19, 2003

%Declaration of variables
var picLeft, picRight, jumpPic, jumpPicL, attack, attackL, picTemp, land1, land2, land3, lifePic : int
var treeTemp, tree, tree2, panPic, title, titleText, splashR, splashL, level : int
var bossX, bossY, beaver, bossPicL, bossTemp, lives, timer, credits : int
var frame : array 1 .. 6 of int
var fakeGet : string (1)
var enemyCount, enemyX, pancake, pancakeX, pancakeY : array 1 .. 5 of int
var direction : string := "right"
var chars : array char of boolean
var jumpTest, timerStop, attackTest, fall, dead : boolean := false
var marginR : int := 320
var marginL : int := 80
var score, difficulty : int := 0
var font := Font.New ("Arial:24:bold")
var font2 := Font.New ("Arial:50:bold")
var landH, landW, landX, landY, charW, charH, charX, charY : int

% Assignment of picture variables
picRight := Pic.FileNew ("run2Right.bmp")
tree := Pic.FileNew ("eviltreeL1.bmp")
tree2 := Pic.FileNew ("eviltreeL2.bmp")
picLeft := Pic.FileNew ("run2Left.bmp")
jumpPic := Pic.FileNew ("jump.bmp")
jumpPicL := Pic.FileNew ("jumpL.bmp")
picTemp := Pic.FileNew ("run2Right.bmp")
treeTemp := tree
land1 := Pic.FileNew ("land.jpg")
land2 := Pic.FileNew ("land2.jpg")
land3 := Pic.FileNew ("land3.jpg")
attack := Pic.FileNew ("chop.bmp")
attackL := Pic.FileNew ("chopL.bmp")
lifePic := Pic.FileNew ("life.bmp")
panPic := Pic.FileNew ("flapjack.bmp")
title := Pic.FileNew ("title.jpg")
titleText := Pic.FileNew ("titleText.jpg")
splashR := Pic.FileNew ("splashR.bmp")
splashL := Pic.FileNew ("splashL.bmp")
bossPicL := Pic.FileNew ("orc2L.bmp")
beaver := Pic.FileNew ("beaver1.bmp")
credits := Pic.FileNew ("credits.jpg")

% The land height and width
landW := Pic.Width (land1)
landH := Pic.Height (land1)

% The character height and width
charW := Pic.Width (picRight)
charH := Pic.Height (picRight)

% center the land picture on the screen
landX := (landW - maxx) div 2
landY := (landH - maxy) div 2

%Reset all vaiables to 0 for different screen items such as enemies, life items
for i : 1 .. 5
    enemyCount (i) := 1
    enemyX (i) := 0
    pancakeX (i) := 0
    pancakeY (i) := 0
    pancake (i) := 0
end for

%Set the screen resolution and colours
colourback (black)
colour (white)
cls
setscreen ("graphics:788;540,position:middle;centre;nobuttonbar,title:Lumberjack")
setscreen ("offscreenonly")

% process to detect if the character hits a pancake on the screen for life
process pancakeDetection
    for i : 1 .. 5
	if (charX - landX + 50) > ((pancakeX (i) - landX)) and (charX - landX - 50) < (pancakeX (i) - landX + 50) and pancake (i) not= 0 then
	    if (charY - landY + charH) > ((pancakeY (i) - landY)) then
		score += 50
		pancake (i) := 0
		lives += 1
		for j : 1 .. 15
		    Font.Draw ("+1 LIFE", pancakeX (i) - landX, pancakeY (i) - landY + 75 + j, font, brightred)
		    Font.Draw ("50", pancakeX (i) - landX, pancakeY (i) - landY + j, font, brightred)
		end for
	    end if
	end if
    end for
end pancakeDetection

% process for detection of enemies on screen
process enemies
    for i : 1 .. 5
	if (charX - landX + 50) > ((enemyX (i) - landX)) and (charX - landX - 50) < (enemyX (i) - landX + 50) and enemyCount (i) = 1 then
	    jumpTest := false
	    lives -= 1
	    if direction = "right" then
		charX -= 150
	    elsif direction = "left" then
		charX += 150
	    end if
	end if
    end for
end enemies

% process for collision during the chase in the second level
process chase
    if (charX - landX) < (bossX - landX + Pic.Width (beaver) - 80) then
	jumpTest := false
	lives -= 1
	charX += 150
	bossX -= 40
    end if
end chase

% process for collision in the third level
process enemyLast
    if (charX + 50) > (bossX) then
	jumpTest := false
	lives -= 1
	charX -= 80
    end if
end enemyLast

% process to count down the timer
process countDown
    loop
	exit when timerStop = true
	delay (1000)
	timer -= 1
    end loop
end countDown

% process for the screen boundries
process boundry
    % move the land when the character is too far right
    if charX + charW > landW - marginR then
	charX := landW - marginR - charW
    elsif charX - marginL < 0 then
	charX := marginL
    end if

    % move the land when charcter is too far left
    if (charX + charW) - landX > maxx - marginR then
	landX := charX + charW - maxx + marginR
    elsif charX - landX < marginL then
	landX := charX - marginL
    end if
end boundry

% process which makes the character fall in levels 1 and 2, it also takes one life
process level1Obstacles
    fall := true
    loop
	% sets the fall picture to draw
	if direction = "right" then
	    picTemp := jumpPic
	    charY -= 3
	elsif direction = "left" then
	    picTemp := jumpPicL
	    charY -= 3
	end if
	if level = 1 then
	    exit when charY < -400
	elsif level = 2 then
	    exit when charY < 250

	end if
    end loop
    % picture of splash for level 2
    for i : 1 .. 80
	if direction = "right" then
	    picTemp := splashR
	elsif direction = "left" then
	    picTemp := splashL
	end if
    end for
    % replacement on the screen
    picTemp := picRight
    if lives > 0 then
	charX -= 250
	charY := 309
    end if
    lives -= 1
    fall := false
end level1Obstacles

% falling process for level 3
process level3Obstacles
    fall := true
    loop
	% set the fall picture to draw
	if direction = "right" then
	    picTemp := jumpPic
	    charY -= 3
	elsif direction = "left" then
	    picTemp := jumpPicL
	    charY -= 3
	end if
	exit when charY < -400
    end loop
    picTemp := picRight
    if lives > 0 then
	charX := 300
	charY := 309
    end if
    lives -= 1
    fall := false
end level3Obstacles

% this is the jump process when the up key if pressed
process jump
    loop
	% char goes up until he reaches 430 or until he hits an object
	exit when jumpTest = false
	charY += 2
	if direction = "right" then
	    picTemp := jumpPic
	elsif direction = "left" then
	    picTemp := jumpPicL
	end if
	exit when charY >= 430
    end loop
    loop
	% char goes down until he hits the ground again
	charY -= 2
	if charY < 309 then
	    charY := 309
	end if
	exit when charY = 309
	if direction = "right" then
	    picTemp := jumpPic
	elsif direction = "left" then
	    picTemp := jumpPicL
	end if
    end loop
    delay (100)
    jumpTest := false
    if direction = "right" then
	picTemp := picRight
    elsif direction = "left" then
	picTemp := picLeft
    end if
end jump

% attack procedure for levels 1 and 2
process attackThings
    var temp : int
    temp := 0
    % detect whether a tree has been hit in level 1
    for i : 1 .. 5
	if enemyCount (i) not= 0 then
	    if direction = "right" then
		if (charX - landX + 80) >= ((enemyX (i) - landX - 50)) then
		    enemyCount (i) := 0
		    score += 25
		end if
	    end if
	end if
    end for
    %set attack pic
    for i : 1 .. 40
	temp += 1
	if direction = "right" then
	    picTemp := attack
	elsif direction = "left" then
	    picTemp := attackL
	end if
    end for
    delay (100)
    attackTest := false
    if direction = "right" then
	picTemp := picRight
    elsif direction = "left" then
	picTemp := picLeft
    end if
end attackThings

% same as above  procedure but for level 3
process attackThings2
    var temp : int
    temp := 0
    if (charX + 120) >= bossX then
	bossX += 140
    end if
    for i : 1 .. 40
	temp += 1
	if direction = "right" then
	    picTemp := attack
	elsif direction = "left" then
	    picTemp := attackL
	end if
    end for
    delay (100)
    attackTest := false
    if direction = "right" then
	picTemp := picRight
    elsif direction = "left" then
	picTemp := picLeft
    end if
end attackThings2

% process to play the music files
process music (file : string)
    Music.PlayFile (file)
end music

% this is the procedure to do the comic book cutscenes between levels
procedure cutScenes (level, numFrame : int)
    % sets the frames into the array
    for i : 1 .. numFrame
	frame (i) := Pic.FileNew (intstr (level) + "frame" + intstr (i) + ".jpg")
    end for
    % displays the frames from the array
    for i : 1 .. numFrame
	cls
	Pic.Draw (frame (i), 261, 1, picCopy)
	View.Update
	delay (4000)
    end for
end cutScenes

% this procedure is used to draw the pancakes
procedure drawCakes
    for i : 1 .. 5
	if pancake (i) = 1 then
	    Pic.Draw (panPic, pancakeX (i) - landX, pancakeY (i) - landY, picMerge)
	end if
    end for
end drawCakes

% procedure to draw all the screen elements like score
procedure screenElements
    Font.Draw ("SCORE:", 500, 505, font, brightred)
    Font.Draw (intstr (score), 630, 505, font, brightred)
    Font.Draw ("TIME:", 500, 105, font, brightred)
    Font.Draw (intstr (timer), 630, 105, font, brightred)
    Font.Draw ("LIVES:", 20, 505, font, brightred)
    if lives >= 7 then
	Pic.Draw (lifePic, 130, 495, picCopy)
	Font.Draw (" X " + intstr (lives), 200, 505, font, brightred)
    elsif lives = 6 then
	Pic.Draw (lifePic, 130, 495, picCopy)
	Pic.Draw (lifePic, 200, 495, picCopy)
	Pic.Draw (lifePic, 270, 495, picCopy)
	Pic.Draw (lifePic, 340, 495, picCopy)
	Pic.Draw (lifePic, 410, 495, picCopy)
    elsif lives = 5 then
	Pic.Draw (lifePic, 130, 495, picCopy)
	Pic.Draw (lifePic, 200, 495, picCopy)
	Pic.Draw (lifePic, 270, 495, picCopy)
	Pic.Draw (lifePic, 340, 495, picCopy)
    elsif lives = 4 then
	Pic.Draw (lifePic, 130, 495, picCopy)
	Pic.Draw (lifePic, 200, 495, picCopy)
	Pic.Draw (lifePic, 270, 495, picCopy)
    elsif lives = 3 then
	Pic.Draw (lifePic, 130, 495, picCopy)
	Pic.Draw (lifePic, 200, 495, picCopy)
    elsif lives = 2 then
	Pic.Draw (lifePic, 130, 495, picCopy)
    end if
end screenElements

% Main Game Loop
loop
    % opening screen
    loop
	fork music ("intro.mid")
	colourback (black)
	color (white)
	cls
	Pic.Draw (title, 0, 0, picCopy)
	View.Update
	delay (1000)
	Pic.Draw (titleText, 0, 0, picMerge)
	View.Update
	delay (5000)
	% difficulty selection
	loop
	    cls
	    Pic.Draw (title, 0, 0, picCopy)
	    Input.KeyDown (chars)
	    if chars (KEY_UP_ARROW) then
		if difficulty not= 0 then
		    difficulty -= 1
		end if
	    elsif chars (KEY_DOWN_ARROW) then
		if difficulty not= 6 then
		    difficulty += 1
		end if
	    end if
	    if chars (KEY_ENTER) then
		if difficulty = 0 or difficulty = 1 then
		    timer := 100
		    lives := 5
		    exit
		elsif difficulty = 2 or difficulty = 3 then
		    timer := 60
		    lives := 4
		    exit
		elsif difficulty = 4 or difficulty = 5 then
		    timer := 40
		    lives := 2
		    exit
		elsif difficulty = 6 or difficulty = 7 then
		    cls
		    put "Welcome to Wood Wacker"
		    put "Your goal is to reach the end of the level of all 3 levels without dieing"
		    put "If you do not complete a level in the amount of time, it's game over"
		    put "You must run (the left and right arrow keys) through the levels and"
		    put "jump over the holes (the up arrow key) while killing enemies (the enter key)"
		    put "You will recieve a life and 50 points for every flap jack you run into."
		    put "You will lose a life if you fall down a hole or hit an enemy."
		    put "I hope you enjoy the game"
		    put " "
		    put "[HIT ANY KEY TO CONTINUE]"
		    View.Update
		    getch (fakeGet)
		    difficulty := 0
		end if

	    end if
	    if difficulty = 0 then
		Font.Draw ("EASY", 200, 300, font2, brightred)
		Font.Draw ("MEDIUM", 200, 250, font2, red)
		Font.Draw ("HARD", 200, 200, font2, red)
		Font.Draw ("INSTRUCTIONS", 200, 150, font2, red)
		View.Update
	    elsif difficulty = 2 then
		Font.Draw ("EASY", 200, 300, font2, red)
		Font.Draw ("MEDIUM", 200, 250, font2, brightred)
		Font.Draw ("HARD", 200, 200, font2, red)
		Font.Draw ("INSTRUCTIONS", 200, 150, font2, red)
		View.Update
	    elsif difficulty = 4 then
		Font.Draw ("EASY", 200, 300, font2, red)
		Font.Draw ("MEDIUM", 200, 250, font2, red)
		Font.Draw ("HARD", 200, 200, font2, brightred)
		Font.Draw ("INSTRUCTIONS", 200, 150, font2, red)
		View.Update
	    elsif difficulty = 6 then
		Font.Draw ("EASY", 200, 300, font2, red)
		Font.Draw ("MEDIUM", 200, 250, font2, red)
		Font.Draw ("HARD", 200, 200, font2, red)
		Font.Draw ("INSTRUCTIONS", 200, 150, font2, brightred)
		View.Update
	    end if
	end loop
	Music.PlayFileStop

	%reset all the variables to play
	score := 0
	charX := 94
	charY := 309
	bossX := 5157
	bossY := 309
	bossTemp := bossPicL
	enemyX (1) := 230
	enemyX (2) := 1264
	enemyX (3) := 2808
	enemyX (4) := 3725
	enemyX (5) := 4637
	pancakeX (1) := 3460
	pancakeY (1) := 460
	pancake (1) := 1
	pancakeX (2) := 1460
	pancakeY (2) := 460
	pancake (2) := 2
	level := 1
	timerStop := false
	fall := false
	dead := false

	cutScenes (1, 6)
	fork countDown
	fork music ("level1.mid")

	% level 1
	loop
	    fork boundry
	    fork enemies
	    fork pancakeDetection

	    % player control
	    Input.KeyDown (chars)
	    if chars (KEY_UP_ARROW) and jumpTest = false then
		jumpTest := true
		fork jump
	    elsif chars (KEY_RIGHT_ARROW) and jumpTest = false and fall = false then
		direction := "right"
		charX += 14
		picTemp := Pic.FileNew ("run" + intstr ((charX mod 3) + 1) + "Right.bmp")
	    elsif chars (KEY_LEFT_ARROW) and jumpTest = false and fall = false then
		direction := "left"
		charX -= 14
		picTemp := Pic.FileNew ("run" + intstr ((charX mod 3) + 1) + "Left.bmp")
	    elsif chars (KEY_ENTER) and attackTest = false and jumpTest = false then
		attackTest := true
		fork attackThings
	    end if
	    if chars (KEY_RIGHT_ARROW) and jumpTest = true then
		direction := "right"
		charX += 30
	    elsif chars (KEY_LEFT_ARROW) and jumpTest = true then
		direction := "left"
		charX -= 30
	    end if

	    % Level holes
	    if fall = false then
		if charX > 696 and charX < 795 and charY = 309 then
		    fork level1Obstacles
		elsif charX > 2096 and charX < 2228 and charY = 309 then
		    fork level1Obstacles
		elsif charX > 2418 and charX < 2475 and charY = 309 then
		    fork level1Obstacles
		elsif charX > 3034 and charX < 3188 and charY = 309 then
		    fork level1Obstacles
		elsif charX > 4342 and charX < 4482 and charY = 309 then
		    fork level1Obstacles
		end if
	    end if

	    % Redrawing the pictures for animation
	    cls
	    Pic.Draw (land1, -landX, -landY, picCopy)
	    Pic.Draw (picTemp, charX - landX, charY - landY, picMerge)
	    Pic.Draw (bossTemp, bossX - landX, bossY - landY, picMerge)

	    % enemies
	    for i : 1 .. 5
		if enemyCount (i) = 1 then
		    Pic.Draw (treeTemp, enemyX (i) - landX, 309 - landY, picMerge)
		end if
	    end for
	    drawCakes
	    screenElements
	    View.Update

	    % sets the direction the person is travelling
	    if direction = "right" then
		picTemp := picRight
	    elsif direction = "left" then
		picTemp := picLeft
	    elsif direction = "jump" then
		picTemp := jumpPic
	    end if

	    % enemy animation
	    if treeTemp = tree then
		treeTemp := tree2
	    else
		treeTemp := tree
	    end if

	    % exits if you are out of lives or time is up
	    if lives <= 0 or timer = 0 then
		timerStop := true
		dead := true
		exit
	    end if

	    % exits when level beaten
	    if charX >= 5031 then
		timerStop := true
		exit
	    end if
	end loop

	exit when timer <= 0 or dead

	Music.PlayFileStop

	% little animation cut sequence
	for i : 1 .. 5
	    bossTemp := Pic.FileNew ("orc" + intstr (((bossX - landX) mod 3) + 1) + "R.bmp")
	    cls
	    bossX += 13
	    Pic.Draw (land1, -landX, -landY, picCopy)
	    Pic.Draw (picTemp, charX - landX, charY - landY, picMerge)
	    Pic.Draw (bossTemp, bossX - landX, bossY - landY, picMerge)
	    screenElements
	    View.Update
	end for
	for i : 1 .. 6
	    bossTemp := Pic.FileNew ("orc2R.bmp")
	    cls
	    bossX += 10
	    bossY += 10
	    Pic.Draw (land1, -landX, -landY, picCopy)
	    Pic.Draw (picTemp, charX - landX, charY - landY, picMerge)
	    Pic.Draw (bossTemp, bossX - landX, bossY - landY, picMerge)
	    screenElements
	    View.Update
	end for
	for i : 1 .. 6
	    cls
	    bossX += 10
	    bossY -= 10
	    Pic.Draw (land1, -landX, -landY, picCopy)
	    Pic.Draw (picTemp, charX - landX, charY - landY, picMerge)
	    Pic.Draw (bossTemp, bossX - landX, bossY - landY, picMerge)
	    screenElements
	    View.Update
	end for
	for i : 1 .. 9
	    bossTemp := Pic.FileNew ("orc" + intstr (((bossX - landX) mod 3) + 1) + "R.bmp")
	    cls
	    bossX += 13
	    bossY -= 2
	    Pic.Draw (land1, -landX, -landY, picCopy)
	    Pic.Draw (picTemp, charX - landX, charY - landY, picMerge)
	    Pic.Draw (bossTemp, bossX - landX, bossY - landY, picMerge)
	    screenElements
	    View.Update
	end for

	% scoring for leftover time
	loop
	    exit when timer = 0
	    cls
	    timer -= 1
	    score += 2
	    Pic.Draw (land1, -landX, -landY, picCopy)
	    Pic.Draw (picTemp, charX - landX, charY - landY, picMerge)
	    Pic.Draw (bossTemp, bossX - landX, bossY - landY, picMerge)
	    screenElements
	    View.Update
	end loop

	% reset all the variables
	for i : 1 .. 5
	    pancake (i) := 0
	end for
	timer := 60
	bossX := -12
	bossY := 309
	bossTemp := Pic.FileNew ("beaver1.bmp")
	landX := 60
	charX := 370
	charY := 309
	pancakeX (1) := 1560
	pancakeY (1) := 460
	pancake (1) := 1
	pancakeX (2) := 3460
	pancakeY (2) := 460
	pancake (2) := 1
	level := 2
	cutScenes (2, 3)
	timerStop := false
	fall := false
	fork countDown
	fork music ("level2.mid")
	loop
	    var progress : int := 13 % variable for progress of beaver
	    bossX += progress

	    % boss animation picture
	    bossTemp := Pic.FileNew ("beaver" + intstr ((bossX) mod 3 + 1) + ".bmp")
	    fork boundry
	    fork chase
	    fork pancakeDetection

	    % player controls
	    Input.KeyDown (chars)
	    if chars (KEY_UP_ARROW) and jumpTest = false then
		jumpTest := true
		fork jump
	    elsif chars (KEY_RIGHT_ARROW) and jumpTest = false and charY = 309 then
		direction := "right"
		charX += 17
		picTemp := Pic.FileNew ("run" + intstr ((charX mod 3) + 1) + "Right.bmp")
	    elsif chars (KEY_LEFT_ARROW) and jumpTest = false and charY = 309 then
		direction := "left"
		charX -= 17
		picTemp := Pic.FileNew ("run" + intstr ((charX mod 3) + 1) + "Left.bmp")
	    elsif chars (KEY_ENTER) and attackTest = false and jumpTest = false then
		attackTest := true
		fork attackThings
	    end if
	    if chars (KEY_RIGHT_ARROW) and jumpTest = true then
		direction := "right"
		charX += 30
	    elsif chars (KEY_LEFT_ARROW) and jumpTest = true then
		direction := "left"
		charX -= 30
	    end if

	    % Level holes
	    if fall = false then
		if (charX) > 556 and (charX) < 720 and charY = 309 then
		    fork level1Obstacles
		elsif charX > 1480 and charX < 1670 and charY = 309 then
		    fork level1Obstacles
		elsif charX > 1956 and charX < 2078 and charY = 309 then
		    fork level1Obstacles
		elsif charX > 2376 and charX < 2512 and charY = 309 then
		    fork level1Obstacles
		elsif charX > 2796 and charX < 2948 and charY = 309 then
		    fork level1Obstacles
		elsif charX > 3688 and charX < 3868 and charY = 309 then
		    fork level1Obstacles
		elsif charX > 4150 and charX < 4246 and charY = 309 then
		    fork level1Obstacles
		elsif charX > 4528 and charX < 4728 and charY = 309 then
		    fork level1Obstacles
		end if
	    end if

	    % Redrawing the pictures for animation
	    cls
	    Pic.Draw (land2, -landX, -landY, picCopy)
	    Pic.Draw (picTemp, charX - landX, charY - landY, picMerge)
	    Pic.Draw (bossTemp, bossX - landX, bossY - landY, picMerge)
	    screenElements
	    drawCakes
	    View.Update

	    % sets the direction the person is travelling
	    if direction = "right" then
		picTemp := picRight
	    elsif direction = "left" then
		picTemp := picLeft
	    elsif direction = "jump" then
		picTemp := jumpPic
	    end if

	    % exits if you are out of lives or time is up
	    if lives <= 0 or timer <= 0 then
		timerStop := true
		dead := true
		exit
	    end if

	    % exit when finished the level
	    if charX >= 5045 then
		timerStop := true
		exit
	    end if
	end loop

	exit when timer <= 0 or dead

	% little nimation cut sequence
	bossX := 4700
	for i : 1 .. 30
	    var progress : int := 13
	    bossX += progress
	    charX += 17
	    cls
	    picTemp := Pic.FileNew ("run" + intstr ((charX mod 3) + 1) + "Right.bmp")
	    bossTemp := Pic.FileNew ("beaver" + intstr ((bossX) mod 3 + 1) + ".bmp")
	    Pic.Draw (land2, -landX, -landY, picCopy)
	    Pic.Draw (picTemp, charX - landX, charY - landY, picMerge)
	    Pic.Draw (bossTemp, bossX - landX, bossY - landY, picMerge)
	    screenElements
	    View.Update
	end for

	% scoring for time left
	if timer not= 0 then
	    loop
		exit when timer = 0
		cls
		timer -= 1
		score += 2
		Pic.Draw (land2, -landX, -landY, picCopy)
		Pic.Draw (picTemp, charX - landX, charY - landY, picMerge)
		Pic.Draw (bossTemp, bossX - landX, bossY - landY, picMerge)
		screenElements
		View.Update
	    end loop
	end if
	Music.PlayFileStop
	cutScenes (3, 2)

	% reset all the variables
	for i : 1 .. 5
	    pancake (i) := 0
	end for
	timer := 60
	bossX := 470
	bossY := 309
	bossTemp := bossPicL
	landX := 0
	charX := 100
	charY := 309
	timerStop := false
	fall := false
	bossTemp := bossPicL
	fork countDown
	fork music ("level3.mid")

	% level 3
	loop
	    var progress : int := 1
	    fork enemyLast
	    bossX -= progress

	    % player control
	    Input.KeyDown (chars)

	    if chars (KEY_UP_ARROW) and jumpTest = false then
		jumpTest := true
		fork jump
	    elsif chars (KEY_RIGHT_ARROW) and jumpTest = false and charY = 309 then
		direction := "right"
		charX += 12
		picTemp := Pic.FileNew ("run" + intstr ((charX mod 3) + 1) + "Right.bmp")
	    elsif chars (KEY_LEFT_ARROW) and jumpTest = false and charY = 309 then
		direction := "left"
		charX -= 12
		picTemp := Pic.FileNew ("run" + intstr ((charX mod 3) + 1) + "Left.bmp")
	    elsif chars (KEY_ENTER) and attackTest = false and jumpTest = false then
		attackTest := true
		fork attackThings2
	    end if
	    if chars (KEY_RIGHT_ARROW) and jumpTest = true then
		direction := "right"
		charX += 30
	    elsif chars (KEY_LEFT_ARROW) and jumpTest = true then
		direction := "left"
		charX -= 30
	    end if

	    % Level holes
	    if fall = false then
		if charX > 696 or charX < 30 then
		    fork level3Obstacles
		end if
	    end if

	    % Redrawing the pictures for animation
	    cls
	    Pic.Draw (land3, -landX, -landY, picCopy)
	    Pic.Draw (picTemp, charX - landX, charY - landY, picMerge)
	    Pic.Draw (bossTemp, bossX - landX, bossY - landY, picMerge)
	    screenElements
	    View.Update

	    % sets the direction the person is travelling
	    if direction = "right" then
		picTemp := picRight
	    elsif direction = "left" then
		picTemp := picLeft
	    elsif direction = "jump" then
		picTemp := jumpPic
	    end if

	    % exits if you are out of lives
	    if lives <= 0 or timer = 0 then
		timerStop := true
		dead := true
		exit
	    end if

	    % exit when boss hass been killed
	    if bossX > 685 then
		timerStop := true
		exit
	    end if
	end loop

	exit when timer <= 0 or dead

	% falling sequence
	for i : 1 .. 60
	    bossY -= 7
	    cls
	    Pic.Draw (land3, -landX, -landY, picCopy)
	    Pic.Draw (picTemp, charX - landX, charY - landY, picMerge)
	    Pic.Draw (bossTemp, bossX - landX, bossY - landY, picMerge)
	    screenElements
	    View.Update
	end for

	% scoring for time left
	if timer not= 0 then
	    loop
		exit when timer = 0
		cls
		timer -= 1
		score += 2
		Pic.Draw (land3, -landX, -landY, picCopy)
		Pic.Draw (picTemp, charX - landX, charY - landY, picMerge)
		Pic.Draw (bossTemp, bossX - landX, bossY - landY, picMerge)
		screenElements
		View.Update
	    end loop
	end if
	Music.PlayFileStop
	cutScenes (4, 2)
    end loop
    Music.PlayFileStop

    % End Credits if game beaten and Game over display
    charX := 1
    charY := -2400

    if dead = false then
	fork music ("end.mid")
	loop
	    charY += 1
	    cls
	    Pic.Draw (credits, charX, charY, picCopy)
	    View.Update
	    exit when charY > 2100
	end loop
    end if
    cls
    screenElements
    Font.Draw ("GAME OVER", 150, 250, font2, brightred)
    View.Update
    delay (3000)
    Music.PlayFileStop
end loop
